local addon = ActionDurationReminder

---
--@module Ability
--@extends Addon#Class
local module = addon.AddClass(
    "adr.model.Ability"
    ,
    ---
    -- @callof #Ability
    -- @param #Ability self
    -- @param #number id
    -- @param #string name
    -- @param #string icon
    -- @return #Ability
    function(self, id, name, icon)
        self.id = id
        self.name = zo_strformat("<<1>>", name)
        self.icon = icon
        local hasProgression,progressionIndex = GetAbilityProgressionXPInfoFromAbilityId(self.id)
        self.progressionName = hasProgression and GetAbilityProgressionInfo(progressionIndex) or nil
        if self.progressionName and self.progressionName ~= name then
            self.progressionName =  zo_strformat("<<1>>", self.progressionName)
        else
            self.progressionName = nil
        end -- only keep different
        self.description = zo_strformat("<<1>>", GetAbilityDescription(id))
    end
    ,
    ---
    --@param #Ability class
    function(class)
    -- Start Logic
    end
) --#Ability

---
--@param #string s1
--@param #string s2
local function NameMatch(s1, s2)
    if s1 == s2 then return true end
    return string.find(s1, s2,1,true) or string.find(s2, s1,1,true)
end

---
--@param #Ability self
--@param #Ability other
--@param #boolean strict
--@return #boolean whether match
function module:Match(other, strict)
    if self.id==other.id then return true end
    if self.icon == other.icon then return true end
    if NameMatch(self.name , other.name) then return true end
    if self.progressionName and NameMatch(self.progressionName, other.name) then return true end
    if not strict and self.description and NameMatch(self.description, other.name) then return true end
    return false
end

return module
