local addon = ActionDurationReminder --Addon#Addon

---
--@module Effect
--@extends Addon#Class
local module = addon.AddClass(
    "adr.model.Effect"
    ,
    ---
    -- @callof #Effect
    -- @param #Effect self
    -- @param adr.model.Ability#Ability ability
    -- @param #string unitTag
    -- @param #number unitId
    -- @param #number startTime
    -- @param #number endTime
    -- @return #Effect
    function(self, ability, unitTag, unitId, startTime, endTime)
        self.ability = ability
        self.unitTag = unitTag=='player' and 'player' or 'others' -- player or not
        self.unitId = unitId
        self.startTime = startTime
        self.endTime = endTime
        self.duration = endTime-startTime
    end
) --#Effect

---
--@pram #Effect self
--@return #boolean whether on others
function module:IsOnPlayer()
    return self.unitTag == 'player'
end

--========================================
return module
